<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

class WPBakeryShortCode_vc_360product extends WPBakeryShortCode {

	protected function content( $atts, $content = null ) {

		extract( shortcode_atts( array(
			'style'			=>		'cl-effect-1',
			'size'			=>		'18',
			'animate' 		=> 		'',
		), $atts ) );
		$some_id = rand(5, 500);
		$url = vc_build_link($url); 
		wp_enqueue_style( 'creative-css', plugins_url( '../css/creativelink.css' , __FILE__ ));
		wp_enqueue_script( 'sprite-spin', plugins_url( '../js/spritespin.js' , __FILE__ ));
		$content = wpb_js_remove_wpautop($content, true);
		ob_start(); ?>
		
		<a class="button js-fullscreen" href="#">Fullscreen</a>
		<div id="mySpriteSpin"></div>
		<input class="spritespin-slider" type="range">

		<script type='text/javascript'>
			jQuery('a.js-fullscreen').click(function(e) {
			    e.preventDefault();
			    jQuery('#mySpriteSpin').spritespin('api').requestFullscreen();
			});
			jQuery("#mySpriteSpin").spritespin({
				source: [
				"img/001.jpg",
				"img/002.jpg",
				"img/003.jpg",
				"img/004.jpg",
				"img/005.jpg",
				"img/006.jpg",
				"img/007.jpg",
				"img/008.jpg",
				"img/009.jpg",
				"img/010.jpg",
				"img/011.jpg",
				"img/012.jpg",
				"img/013.jpg",
				"img/014.jpg",
				"img/015.jpg",
				"img/016.jpg",
				"img/017.jpg",
				"img/018.jpg",
				"img/019.jpg",
				"img/020.jpg",
				"img/021.jpg",
				"img/022.jpg",
				"img/023.jpg",
				"img/024.jpg",
				"img/025.jpg",
				"img/026.jpg",
				"img/027.jpg",
				"img/028.jpg",
				"img/029.jpg",
				"img/030.jpg",
				"img/031.jpg",
				"img/032.jpg",
				"img/033.jpg",
				"img/034.jpg",
				"img/035.jpg",
				"img/036.jpg",
				"img/037.jpg",
				"img/038.jpg",
				"img/039.jpg",
				"img/040.jpg",
				"img/041.jpg",
				"img/042.jpg",
				"img/043.jpg",
				"img/044.jpg",
				"img/045.jpg",
				"img/046.jpg",
				"img/047.jpg",
				"img/048.jpg",
				"img/049.jpg",
				"img/050.jpg",
				"img/051.jpg",
				"img/052.jpg",
				"img/053.jpg",
				"img/054.jpg",
				"img/055.jpg",
				"img/056.jpg",
				"img/057.jpg",
				"img/058.jpg",
				"img/059.jpg",
				"img/060.jpg",
				"img/061.jpg",
				"img/062.jpg",
				"img/063.jpg",
				"img/064.jpg",
				"img/065.jpg",
				"img/066.jpg",
				"img/067.jpg",
				"img/068.jpg",
				"img/069.jpg",
				"img/070.jpg",
				],
		  	width : 600,
			height: 400,
			
			sense : -1,
			animate : true,
			loop: true,
			frameWrap : true,
			frameStep : 1,
			frameTime : 60,
			enableCanvas : true,
			// responsive: true,
			plugins: [
		      '360',
		      'ease',
		      'drag',
		      'blur'
		    ],
		    onFrame: function(e, data) {
		      $('.spritespin-slider').val(data.frame)
		    },
		    onInit: function(e, data) {
		      $('.spritespin-slider')
		        .attr("min", 0)
		        .attr("max", data.source.length - 1)
		        .attr("value", 0)
		        .on("input", function(e) {
		          SpriteSpin.updateFrame(data, e.target.value);
		        })
		    }
			});
		</script>

		<?php
		return ob_get_clean();
	}
}


vc_map( array(
	"name" 			=> __( '360 Product Viewer', '360view' ),
	"base" 			=> "vc_360product",
	"category" 		=> __('Mega Addons'),
	"description" 	=> __('Turns image frames into 360 degree view of product.', '360view'),
	"icon" => plugin_dir_url( __FILE__ ).'../icons/360view.png',
	'params' => array(
		array(
			"type" 			=> 	"attach_images",
			"heading" 		=> 	__( 'Images', '360view' ),
			"param_name" 	=> 	"image_ids",
			"description" 	=> 	__( 'Select the images that will be used as product viewer <a href="https://addons.topdigitaltrends.net/flip-book/" target="_blank">See Demo</a>', 'photobook' ),
			"group" 		=> 	'General',
		),

		array(
			"type" 			=> "vc_number",
			"heading" 		=> __( 'Image Width', '360view' ),
			"param_name" 	=> "img_width",
			"suffix" 		=> 'px',
			"group" 		=> 'General',
		),

	    array(
			"type" 			=> "vc_number",
			"heading" 		=> __( 'Image Height', '360view' ),
			"param_name" 	=> "img_height",
			"suffix" 		=> 'px',
			"group" 		=> 'General',
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Animate', '360view' ),
			"param_name" 	=> 	"animate",
			"description" 	=> 	__( 'If true, starts the animation automatically on load', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Loop', '360view' ),
			"param_name" 	=> 	"loop",
			"description" 	=> 	__( 'If true, continues playback in a loop.', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Reverse', '360view' ),
			"param_name" 	=> 	"reverse",
			"description" 	=> 	__( 'If true, animation playback is reversed', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Retain Animate', '360view' ),
			"param_name" 	=> 	"retainanimate",
			"description" 	=> 	__( 'If true, retains the animation after user iser interaction', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

		array(
			"type" 			=> 	"vc_number",
			"heading" 		=> 	__( 'Frame', '360view' ),
			"param_name" 	=> 	"frame",
			"description" 	=> 	__( 'Initial frame number.', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=>  "1",
		),

		array(
			"type" 			=> 	"vc_number",
			"heading" 		=> 	__( 'FrameTime', '360view' ),
			"param_name" 	=> 	"frameTime",
			"description" 	=> 	__( 'Time in ms between updates. e.g. 40 is exactly 25 FPS', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=>  "60",
		),

		array(
			"type" 			=> 	"dropdown",
			"heading" 		=> 	__( 'Behavior', '360view' ),
			"param_name" 	=> 	"behavior",
			"description" 	=> 	__( 'Direction of the overall page organization', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
				"Drag"			=> "drag", 
				"Mouse Move" 	=> "move",
				"Mouse Wheel" 	=> "wheel",
			)
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Slider', '360view' ),
			"param_name" 	=> 	"slider",
			"description" 	=> 	__( 'move product viewer with slider', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

		array(
			"type" 			=> "vc_links",
			"param_name" 	=> "caption_url",
			"class"			=>	"ult_param_heading",
			"description" 	=> __( '<span style="Background: #ddd;padding: 10px; display: block; color: #302f2f;font-weight:600;">Additional Options</span>', 'ihover' ),
			"group" 		=> 'Options',
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Full Screen', '360view' ),
			"param_name" 	=> 	"fullscreen",
			"description" 	=> 	__( 'show full screen button', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Ease', '360view' ),
			"param_name" 	=> 	"ease",
			"description" 	=> 	__( 'module that eases out an animation after mouse is released', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

		array(
			"type" 			=> 	"checkbox",
			"heading" 		=> 	__( 'Blur', '360view' ),
			"param_name" 	=> 	"blur",
			"description" 	=> 	__( 'module that render and fades additional frames to somulate blur', '360view' ),
			"group" 		=> 	'Options',
			"value" 		=> array(
					"Enable"		=> "true",
			)
		),

	),
) );

